﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Media.Animation;

namespace Musiclibrary
{
	/// <summary>
	/// A button that shows a textbox when it is clicked. Used to add playlists (bottom left corner).
	/// </summary>
	public partial class AddItemButton : UserControl
	{
		public AddItemButton()
		{
			this.InitializeComponent();
		}
		
		public string Label
		{
			get { return (string)this.GetValue(LabelProperty); }
			set { this.SetValue(LabelProperty, value); } 
		}
		public static readonly DependencyProperty LabelProperty = DependencyProperty.Register(
			"Label", typeof(string), typeof(AddItemButton),new PropertyMetadata());
		
		public string Value
		{
			get { return (string)this.GetValue(ValueProperty); }
			set { this.SetValue(ValueProperty, value); } 
		}
		public static readonly DependencyProperty ValueProperty = DependencyProperty.Register(
			"Value", typeof(string), typeof(AddItemButton),new PropertyMetadata(""));

		public event Action<AddItemButton, EventArgs> ItemAdded;

        public bool IsEditing { get; protected set; }

        public void BeginEdit() {
            
            this.OKButton.Visibility = Visibility.Visible;
            (this.FindResource("SlideInTextBox") as Storyboard).Begin();
            this.TextBox.Focus();
            this.IsEditing = true;
        }

        public void EndEdit(bool addItem) {
            if (addItem && this.ItemAdded != null)
                this.ItemAdded(this, EventArgs.Empty);

            (this.FindResource("SlideOutTextBox") as Storyboard).Begin();
            new TimeSpan(0, 0, 0, 0, 400).After(() => this.OKButton.Visibility = Visibility.Hidden, this);

            this.Value = "";
            this.IsEditing = false;
        }

		private void Button_Click(object sender, System.Windows.RoutedEventArgs e)
		{
            this.BeginEdit();
		}

        DateTime? OKButtonClick;

		private void OKButton_Click(object sender, System.Windows.RoutedEventArgs e)
		{
            this.OKButtonClick = DateTime.Now;

            this.EndEdit(true);
		}

		private void TextBox_LostFocus(object sender, System.Windows.RoutedEventArgs e)
		{
            this.EndEdit(false);
		}

        private void TextBox_KeyDown(object sender, KeyEventArgs e) {
            //if (e.Key == Key.Enter)
            //    this.EndEdit(true);
            //else if (e.Key == Key.Escape)
            //    this.EndEdit(false);
        }
		
	}
}