﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace Musiclibrary {
    /// <summary>
    /// Represents a playlist from the local library
    /// </summary>
    public partial class Playlist : IPlaylist {
        #region IPlaylist Member

        public ILibrary Library {
            get { return App.This.Library; }
        }

        public IEnumerable<ISong> Songs {
            get { return from i in this.Playlistitems select i.SongSong as ISong; }
        }

        public virtual void AddSong(ISong isong) {
            var song = (Song)isong;
            var item = new Playlistitem() { PlaylistPlaylist = this, SongSong = song };
            App.This.Library.Playlistitems.InsertOnSubmit(item);
            App.This.Library.SubmitChanges();
        }

        public virtual void DeleteSong(ISong isong) {
            var song = (Song)isong;
            var item = from i in App.This.Library.Playlistitems
                       where i.SongSong == song && i.PlaylistPlaylist == this
                       select i;
            App.This.Library.Playlistitems.DeleteOnSubmit(item.Single());
            App.This.Library.SubmitChanges();
        }


        public virtual bool IsEditable {
            get { return true; }
        }

        public virtual bool ItemsEditable {
            get { return true; }
        }

        public virtual void Delete() {
            App.This.Library.Playlists.DeleteOnSubmit(this);
            App.This.Library.SubmitChanges();
        }

        #endregion

    }
}
